<?php

echo 'Making database changes..<br />';

// If SSI.php is in the same place as this file, and SMF isn't defined, this is being run standalone.
if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');
// Hmm... no SSI.php and no SMF?
elseif (!defined('SMF'))
	exit('<b>Error:</b> Cannot install - please verify this script is in the same place as SMF\'s index.php.');
// Dead database connection?
global $db_connection;
if (!$db_connection)
	exit('<b>Error:</b> Could not connect to database.');

$failures = array();

/*******************************************************************************
* Change these values as needed.                                               *
*******************************************************************************/

// Set the below to true to overwrite already existing settings with the defaults. (not recommended.)
$overwrite_columns = false;
$overwrite_mod_settings = false;

// List settings here in the format: setting_key => default_value.  Escape any "s. (" => \")
$mod_settings = array(
	'personalIconsEnabled' => '0',
	'personalIconsMaxHeight' => '20',
	'personalIconsMaxWidth' => '20',
);

// Columns: table_name => array() with the name as the key and the text MySQL expects (ex. 'personalIcon tinytext NOT NULL').
$add_columns = array(
	$db_prefix . 'members' => array(
  		'personalIcon' => 'personalIcon tinytext NOT NULL',
	),
);

/*******************************************************************************
* First add in the modSettings.                                                *
*******************************************************************************/

// Turn the array defined above into a string of MySQL data.
$string = '';
foreach ($mod_settings as $k => $v)
	$string .= '
			(\'' . $k . '\', \'' . $v . '\'),';

// Sorted out the array defined above - now insert the data!
if ($string != '')
{
	echo 'Adding modSettings...<br />';

	$mod_settings_result = mysql_query("
		" . ($overwrite_mod_settings ? 'REPLACE' : 'INSERT IGNORE') . " INTO {$db_prefix}settings
			(variable, value)
		VALUES" . substr($string, 0, -1), $db_connection);

	// Ok, it failed..
	if (!$mod_settings_result)
		$failures[] = 'Could not insert values into the settings table.';
}

/*******************************************************************************
* Now we will work with the columns.                                           *
*******************************************************************************/

$current_table_columns = array();
foreach ($add_columns as $table_name => $add_columns)
{
	$current_table_columns[$table_name] = array();
	
	// First fill up a list of current columns..
	$request = mysql_query("
		SHOW COLUMNS
		FROM {$table_name}", $db_connection);
	while ($row = mysql_fetch_assoc($request))
		$current_table_columns[$table_name][$row['Field']] = $row['Field'];
	mysql_free_result($request);

	// Now add in all of the columns we want.
	foreach ($add_columns as $add_column_name => $add_column_string)
	{
		echo $overwrite_columns ? 'Overwriting' : 'Adding' ,' column ', $add_column_name ,'...<br />';

		// Delete the current column if we don't want to replace it.
		if ($overwrite_columns && in_array($add_column_name, $current_table_columns[$table_name]))
		{
			// Drop it like it's hot.
			$result = mysql_query("
				ALTER TABLE {$table_name}
				DROP COLUMN {$add_column_name}", $db_connection);
			if (!$result)
				$failuers[] = 'Could not overwrite column ' . $add_column_name . '.';

			// Good, it's gone. Drop it out of the current column array.
			unset($current_table_columns[$table_name][$add_column_name]);
		}
		
		// Add the column now.
		if (!in_array($add_column_name, $current_table_columns[$table_name]))
		{
			// Drop it like it's hot.
			$result = mysql_query("
				ALTER TABLE {$table_name}
				ADD COLUMN {$add_column_string}", $db_connection);
			if (!$result)
				$failuers[] = 'Could not add column ' . $add_column_name . '.';
		}
	}
}

/*******************************************************************************
* Errors!                                                                      *
*******************************************************************************/

foreach ($failures as $error)
	echo '<b>Database Error:</b> ', $error ,'<br />';

?>
